#ifndef TIMINGSINGLETON_H
#define TIMINGSINGLETON_H
#include <sys/time.h>

class TimingSingleton {
private:
	int64_t fldstartTime;
	int64_t fldtotalTime;

public:
	TimingSingleton() : fldstartTime(0),
		fldtotalTime(0) {
	}

	int64_t nanoTime() {
		int64_t time;
		struct timeval tv;
		gettimeofday(&tv, NULL);
		return tv.tv_sec * 1000000000 + tv.tv_usec * 1000;
	}

	void startTime() {
		fldstartTime = nanoTime();
	}

	void endTime() {
		fldtotalTime += nanoTime() - fldstartTime;
	}

	int64_t getTime() {
		return fldtotalTime;
	}
};

TimingSingleton t_singleton;
TimingSingleton *TimingSingleton_getInstance() {
	return &t_singleton;
}
#endif
